; CONSOLE !DEBUG CLEAN RESOURCE MAKEALL LINKALL !VERBOSE
; 

    M32FOLDER TEXTEQU <\masm32>
    
    include     ASMRT.inc
    include     USER32.inc
    include     SHLWAPI.inc
    
    includelib  ASMRT.lib
    includelib  USER32.lib
    includelib  SHLWAPI.lib
    
    run_synch_process PROTO spCommand:DWORD
    
; 

FILETIME STRUCT
  dwLowDateTime     DWORD      ?
  dwHighDateTime    DWORD      ?
FILETIME ENDS

WIN32_FIND_DATA STRUCT
  dwFileAttributes      DWORD      ?
  ftCreationTime        FILETIME   <>
  ftLastAccessTime      FILETIME   <>
  ftLastWriteTime       FILETIME   <>
  nFileSizeHigh         DWORD      ?
  nFileSizeLow          DWORD      ?
  dwReserved0           DWORD      ?
  dwReserved1           DWORD      ?
  cFileName             BYTE 260 dup (?)
  cAlternate            BYTE 14 dup (?)
WIN32_FIND_DATA ENDS

    .data?
        FindFileData WIN32_FIND_DATA <>

; 

    include CommandLine.inc

; 

      ; CONSOLE DISPLAY STRINGS
      ;  in rsrc.rc
        sidPressAnyKey       EQU 01h
        sidAssemblingWith    EQU 0Fh

        sidMsgVERBOSE        EQU 00h
        sidMsgMAKEITBAT      EQU 10h
        sidMsgCLEAN          EQU 11h
        sidMsgNOMAKEIT       EQU 12h
        sidMsgNOPATHS        EQU 13h
        
        sidMsgPOASM          EQU 20h
        sidMsgDEBUG          EQU 21h
        sidMsgLIST           EQU 22h
        sidMsgMAKEALL        EQU 23h

        sidMsgLINKNONE       EQU 30h
        sidMsgPOLINK         EQU 31h
        sidMsgLINK16         EQU 32h
        sidMsgCONSOLE        EQU 33h
        sidMsgRESOURCE       EQU 34h
        sidMsgDLL            EQU 35h
        sidMsgLIB            EQU 36h
        sidMsgLINKALL        EQU 37h
        sidMsgSWAPRUN        EQU 38h
        
        sidExecute           EQU 40h
        
        sidBuildFailed       EQU 50h
        sidBuildSuccess      EQU 51h
        
        sidLogo              EQU 100h
        sidUsage             EQU 110h

; -------------------------------------------------------------------------

SetOption MACRO optvalue:REQ
    invoke  StringFind, spFileFlags, 1, OFFSET s&optvalue
    .if(eax == 1)
        or  dwOptions, optvalue
    .elseif(eax > 1)
        add eax, spFileFlags
        .if(BYTE PTR [eax-2] == '!')
            and dwOptions, NOT optvalue
        .else
            or  dwOptions, optvalue
        .endif
    .endif
    invoke  StringFind, spCommandFlags, 1, OFFSET s&optvalue
    .if(eax == 1)
        or  dwOptions, optvalue
    .elseif(eax > 1)
        add eax, spCommandFlags
        .if(BYTE PTR [eax-2] == '!')
            and dwOptions, NOT optvalue
        .else
            or  dwOptions, optvalue
        .endif
    .endif
ENDM

PrintOption MACRO optvalue:REQ
    .if(dwOptions & optvalue)
        PrintRes sidMsg&optvalue
    .endif
ENDM
    
        VERBOSE     EQU     00000001h
        CLEAN       EQU     00000002h
        NOMAKEIT    EQU     00000004h
        NOPATHS     EQU     00000008h

        POASM       EQU     00000010h
        DEBUG       EQU     00000020h
        LIST        EQU     00000040h
        MAKEALL     EQU     00000080h

        LINKNONE    EQU     00001000h
        POLINK      EQU     00002000h
        LINK16      EQU     00004000h
        CONSOLE     EQU     00008000h
        RESOURCE    EQU     00010000h
        DLL         EQU     00020000h
        LIB         EQU     00040000h
        LINKALL     EQU     00080000h
        SWAPRUN     EQU     00100000h
    
    .const
        sVERBOSE    BYTE    "VERBOSE", 0    ; Verbose assembly mode
        sCLEAN      BYTE    "CLEAN", 0      ; Delete temporary files afterwards
        sNOMAKEIT   BYTE    "NOMAKEIT", 0   ; Suppress makeit.bat file
        sNOPATHS    BYTE    "NOPATHS", 0    ; Suppress path variables
        
        sPOASM      BYTE    "POASM", 0      ; Use Pelle's Assembler
        sDEBUG      BYTE    "DEBUG", 0      ; Debug build
        sLIST       BYTE    "LIST", 0       ; Create a file listing
        sMAKEALL    BYTE    "MAKEALL", 0    ; Assemble all ASM files in the directory
        
        sLINKNONE   BYTE    "NOLINK", 0     ; Do not link this file
        sPOLINK     BYTE    "POLINK", 0     ; Use Pelle's Linker (and resource compiler)
        sLINK16     BYTE    "LINK16", 0     ; Use LINK16 (for 16-bit apps)
        sCONSOLE    BYTE    "CONSOLE", 0    ; Console application
        sRESOURCE   BYTE    "RESOURCE", 0   ; Includes resource file
        sDLL        BYTE    "DLL", 0        ; Create a DLL
        sLIB        BYTE    "LIB", 0        ; Create a LIB
        sLINKALL    BYTE    "LINKALL", 0    ; Link ALL OBJ files in the directory
        sSWAPRUN    BYTE    "SWAPRUN", 0    ; Swap run NET & CD
        

; -------------------------------------------------------------------------

    .data
        spCommandBuffer DWORD   0
        spDisplayBuffer DWORD   0
        
        spBinDir        DWORD   0
        spProjectDir    DWORD   0
        spProjectFile   DWORD   0
        sProjectExt     DWORD   0
        
        spCommandFlags  DWORD   0
        spFileFlags     DWORD   0
    
        dwOptions       DWORD   0

    .code

; -------------------------------------------------------------------------
PrintRes MACRO res:REQ
    push    res
    call    PrintResProc
ENDM

PrintResProc PROC dwRes:DWORD
    LOCAL   sString:DWORD
    
    StringAlloc 1024
    mov     sString, eax

    invoke  GetModuleHandle, 0
    invoke  LoadString, eax, dwRes, sString, 1024    
    CPrint  sString
    StringFree sString
    ret
PrintResProc ENDP
; -------------------------------------------------------------------------

DeleteFiles PROC
    invoke  FindFirstFile, eax, OFFSET FindFileData
    .if(eax != -1)
        push    esi
        move    esi, eax
        .repeat
            invoke  DeleteFile, OFFSET FindFileData.cFileName
            invoke  FindNextFile, esi, OFFSET FindFileData
        .until(eax == 0)
        invoke  FindClose, esi
        pop     esi
    .endif
    ret
DeleteFiles ENDP


; 

Main PROC
    ConsoleInit
    
    StringAlloc 260
    move    spBinDir, eax

; -------------------------------------------------------------------------

    PrintRes sidLogo        ; three calls are necessary since the second
    PrintRes sidLogo+1      ; string is automatically generated at compile
    PrintRes sidLogo+2      ; time and cannot be concatenated.

; -------------------------------------------------------------------------
;  Parse Command line

    invoke  GetModuleFileName, 0, spBinDir, 260
    invoke  PathRemoveFileSpec, spBinDir
    mov     eax, Len(spBinDir)
    add     eax, spBinDir
    mov     DWORD PTR [eax], '\'

    invoke  GetCommandLine
    invoke  PathGetArgs, eax
    cmp     BYTE PTR [eax], 0
    je      DisplayUsage
    
    ;invoke  StringCopy, spProjectDir, eax, -1
    move    spProjectDir, Copy(eax)
    move    eax, spProjectDir
    .if(BYTE PTR [eax] == '"')
        inc     eax
        CopyString spProjectDir, eax
        
        mov     eax, InString(1, spProjectDir, '"')
        add     eax, spProjectDir
        move    BYTE PTR [eax-1], 0
    .else
        mov     eax, InString(1, spProjectDir, ' ')
        add     eax, spProjectDir
        dec     eax
        move    BYTE PTR [eax], 0
    .endif
    inc     eax
    move    spCommandFlags, Copy(eax)
    
    move    eax, Len(spProjectDir)
    add     eax, spProjectDir
    .while(BYTE PTR [eax] != '\')
        dec eax
        .if(eax == spProjectDir)
            move    spProjectFile, eax
            move    spProjectDir, 0
            jmp     @F
        .endif
    .endw
    
    move    BYTE PTR [eax], 0
    inc     eax
    move    spProjectFile, Copy(eax)
    
    invoke  SetCurrentDirectory, spProjectDir
    
   @@:
    move    esi, Open(spProjectFile)
    or      esi, esi
    jz      DisplayUsage
    move    spFileFlags, LineInput(esi, 255)
    Close   esi
    
    add     InString(1,spProjectFile,"."), spProjectFile
    push    eax
    invoke  StringLower, eax, 1
    pop     eax
    move    sProjectExt, DWORD PTR [eax-1]

    invoke  StringUpper, spCommandFlags, 1
    invoke  StringUpper, spFileFlags,    1

; -------------------------------------------------------------------------
;  Interpret options
; Command line options have precedence over file options

    move    dwOptions, 0
    
    SetOption   VERBOSE
    SetOption   CLEAN
    SetOption   NOMAKEIT
    SetOption   NOPATHS
    
    SetOption   POASM
    SetOption   DEBUG
    SetOption   LIST
    SetOption   MAKEALL
    
    SetOption   LINKNONE
    SetOption   POLINK
    SetOption   LINK16
    SetOption   CONSOLE
    SetOption   RESOURCE
    SetOption   DLL
    SetOption   LIB
    SetOption   LINKALL
    SetOption   SWAPRUN
    
    .if(!(dwOptions & NOMAKEIT))
        push    esi
        move    esi, "makeit.bat"
        invoke  FindFirstFile, esi, OFFSET FindFileData
        .if(eax != 0 && eax != -1)
            invoke  FindClose, eax
            PrintRes sidMsgMAKEITBAT
            invoke  run_synch_process, esi
            pop     esi
            jmp     Abort
        .endif
        invoke  FindClose, eax
        pop     esi
    .endif
    
    .if(sProjectExt == 'msa.')
        PrintRes    sidAssemblingWith
        PrintOption VERBOSE
        PrintOption CLEAN
        PrintOption NOMAKEIT
        PrintOption NOPATHS
        
        PrintOption POASM
        PrintOption DEBUG
        PrintOption LIST
        PrintOption MAKEALL
        
        PrintOption LINKNONE
        PrintOption POLINK
        PrintOption LINK16
        PrintOption CONSOLE
        PrintOption RESOURCE
        PrintOption DLL
        PrintOption LIB
        PrintOption LINKALL
        PrintOption SWAPRUN
        CPrintLn
        
        .if(dwOptions & LIB)
            ; Cannot produce a LIB and DLL
            
            and     dwOptions, NOT DLL
        .endif
        
        .if(dwOptions & LIST)
            move    edi, Cat(spBinDir, OFFSET MLEXE, OFFSET ASSEMBLE_LIST)
        .elseif(dwOptions & POASM)
            move    edi, Cat(spBinDir, OFFSET POASMEXE)
        .else
            move    edi, Cat(spBinDir, OFFSET MLEXE)
        .endif
        
        .if(!(dwOptions & NOPATHS))
            CatStrings  edi, OFFSET ASSEMBLE_INCLUDE, spBinDir, "..\include "
        .endif
        
        .if(dwOptions & DEBUG)
            CatStrings edi, OFFSET ASSEMBLE_DEBUG
        .endif
        
        .if(dwOptions & MAKEALL)
            push    esi
            move    eax, "*.asm"
            invoke  FindFirstFile, eax, OFFSET FindFileData
            move    esi, eax
            .while(eax != 0 && eax != -1)
                mov     spCommandBuffer, Cat(edi, OFFSET FindFileData.cFileName)
                .if(dwOptions & VERBOSE)
                    Print "\r\nAssembling %[s]:\r\n\t%[s]\r\n", OFFSET FindFileData.cFileName, spCommandBuffer
                .endif
                invoke run_synch_process, spCommandBuffer
                StringFree spCommandBuffer
                .if(eax)
                    invoke  FindClose, esi
                    pop     esi
                    jmp     BuildError
                .endif
                
                invoke  FindNextFile, esi, OFFSET FindFileData
            .endw
            invoke  FindClose, esi
            pop     esi
            CPrintLn
        .else
            move    spCommandBuffer, Cat(edi, spProjectFile)
            
            .if(dwOptions & VERBOSE)
                Print "\r\nAssembling %[s]:\r\n\t%[s]\r\n\r\n", spProjectFile, spCommandBuffer
            .endif
            invoke run_synch_process, spCommandBuffer
            .if(eax)
                jmp     BuildError
            .endif
            
            StringFree spCommandBuffer
        .endif
        
        .if(dwOptions & RESOURCE)
            move    edx, OFFSET RC
            .if(dwOptions & POLINK)
                move    edx, OFFSET PORC
            .endif
            move    spCommandBuffer, Cat(spBinDir, edx)
            .if(dwOptions & VERBOSE)
                Print "\r\nCompiling Resource file:\r\n\t%[s]\r\n", spCommandBuffer
            .endif
            invoke  run_synch_process, spCommandBuffer
            .if(eax)
                jmp     BuildError
            .endif
            
            StringFree spCommandBuffer

            .if(!(dwOptions & POLINK))
                move    spCommandBuffer, Cat(spBinDir, OFFSET CVTRES)
                .if(dwOptions & VERBOSE)
                    Print "Converting Resource file:\r\n\t%[s]\r\n\r\n", spCommandBuffer
                .endif
                invoke  run_synch_process, spCommandBuffer
                .if(eax)
                    jmp     BuildError
                .endif
                
                StringFree spCommandBuffer
            .endif
        .endif
        
        .if(!(dwOptions & LINKNONE))
            .if(dwOptions & LIB)
                .if(dwOptions & POLINK)
                    move    spCommandBuffer, Cat(spBinDir, OFFSET POLIBEXE)
                .else
                    move    spCommandBuffer, Cat(spBinDir, OFFSET LIBEXE)
                .endif
            .else
                .if(dwOptions & POLINK)
                    move    spCommandBuffer, Cat(spBinDir, OFFSET POLINKEXE)
                .else
                    move    spCommandBuffer, Cat(spBinDir, OFFSET LINKEXE)
                .endif
                
                .if(dwOptions & CONSOLE)
                    CatStrings spCommandBuffer, OFFSET SS_CONSOLE
                .else
                    CatStrings spCommandBuffer, OFFSET SS_WINDOWS
                .endif
            .endif
            
            .if(!(dwOptions & NOPATHS))
                CatStrings spCommandBuffer, OFFSET LINK_LIBPATH, spBinDir, "..\lib "
            .endif
            
            .if(dwOptions & DLL)
                CatStrings spCommandBuffer, OFFSET LINK_DLL_FLAG
            .endif
            .if(dwOptions & DEBUG)
                CatStrings spCommandBuffer, OFFSET LINK_DEBUG_FLAG
            .endif
            .if(dwOptions & SWAPRUN)
                CatStrings spCommandBuffer, OFFSET LINK_SWAPRUN_FLAG
            .endif
            
            push    esi
            move    eax, "*.def"
            invoke  FindFirstFile, eax, OFFSET FindFileData
            .if(eax != -1)
                CatStrings spCommandBuffer, OFFSET LINK_DEF_FLAG, OFFSET FindFileData.cFileName, " "
            .endif
            invoke  FindClose, esi
            pop     esi
            
            .if(dwOptions & LINKALL)
                .if(dwOptions & DLL)
                    CatStrings spCommandBuffer, "*.obj /OUT:", Replace(spProjectFile, ".asm",".dll")," "
                .elseif(dwOptions & LIB)
                    CatStrings spCommandBuffer, "*.obj /OUT:", Replace(spProjectFile, ".asm",".lib")," "
                .else
                    CatStrings spCommandBuffer, "*.obj /OUT:", Replace(spProjectFile, ".asm",".exe")," "
                .endif
                .if((dwOptions & POLINK) && (dwOptions & RESOURCE))
                    CatStrings spCommandBuffer, "rsrc.res "
                .endif
            .else
                CatStrings spCommandBuffer, Replace(spProjectFile, ".asm",".obj")
                .if(dwOptions & RESOURCE)
                    .if(dwOptions & POLINK)
                        CatStrings spCommandBuffer, " rsrc.res "
                    .else
                        CatStrings spCommandBuffer, " rsrc.obj "
                    .endif
                .endif
            .endif
            
            
            .if(dwOptions & VERBOSE)
                Print "\r\nLinking object files:\r\n\t%[s]\r\n\r\n", spCommandBuffer
            .endif
            invoke  run_synch_process, spCommandBuffer
            .if(eax)
                jmp     BuildError
            .endif
            
            StringFree spCommandBuffer
        .endif
        jmp     BuildSuccess
    .elseif(sProjectExt == 'cr.')
        PrintRes    sidAssemblingWith
        PrintRes    sidMsgRESOURCE
        PrintOption POLINK
        
        ; even if CLEAN is set, we don't want to remove the .res file
        and     dwOptions, NOT RESOURCE
        
        .if(dwOptions & POLINK)
            move    spCommandBuffer, Cat(spBinDir, "PORC.EXE ", spProjectFile)
        .else
            move    spCommandBuffer, Cat(spBinDir, "RC.EXE ", spProjectFile)
        .endif
        .if(dwOptions & VERBOSE)
            Print   "\r\nCompiling resource file:\r\n\t%[s]\r\n\r\n", spCommandBuffer
        .endif
        invoke  run_synch_process, spCommandBuffer
        .if(eax)
            jmp     BuildError
        .endif
        StringFree  spCommandBuffer
        jmp     BuildSuccess
    .endif
    
BuildSuccess:
    .if(dwOptions & CLEAN)
        .if(dwOptions & VERBOSE)
            Print "Cleaning up temporary files\r\n\r\n"
        .endif
        .if(dwOptions & RESOURCE)
            move    eax, "*.res"
            call    DeleteFiles
        .endif
        move    eax, "*.obj"
        call    DeleteFiles
        move    eax, "*.ilk"
        call    DeleteFiles
        .if(!(dwOptions & DEBUG))
            move    eax, "*.pdb"
            call    DeleteFiles
        .endif
        move    eax, "*.exp"
        call    DeleteFiles
    .endif


    PrintRes sidBuildSuccess
    CPrintLn
    PrintRes sidPressAnyKey
    CPause
    jmp     Abort
    
BuildError:
    PrintRes sidBuildFailed
    CPrintLn
    PrintRes sidPressAnyKey
    CPause
    
Abort:
    ret
Main ENDP

; 

DisplayUsage:
    PrintRes sidUsage
    invoke  ExitProcess, 2
    ret
    
; 
END _ENTRY
